| VTK 9.0.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkLagrangeTriangle Class Reference

A 2D cell that represents an arbitrary order Lagrange triangle. More...

`#include <vtkLagrangeTriangle.h>`

Inheritance diagram for vtkLagrangeTriangle:
[legend]
Collaboration diagram for vtkLagrangeTriangle:
[legend]

## Public Types
typedef vtkHigherOrderTriangle | Superclass
Public Types inherited from vtkHigherOrderTriangle
typedef vtkNonLinearCell | Superclass
Public Types inherited from vtkNonLinearCell
typedef vtkCell | Superclass
Public Types inherited from vtkCell
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkLagrangeTriangle * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | GetCellType () override
| Return the type of cell. More...
vtkCell * | GetEdge (int edgeId) override
| Return the edge cell from the edgeId of the cell. More...
void | InterpolateFunctions (const double pcoords[3], double *weights) override
void | InterpolateDerivs (const double pcoords[3], double *derivs) override
virtual vtkHigherOrderCurve * | getEdgeCell () override
Public Member Functions inherited from vtkHigherOrderTriangle
vtkHigherOrderTriangle * | NewInstance () const
int | GetCellDimension () override
| Return the topological dimensional of the cell (0,1,2, or 3). More...
int | RequiresInitialization () override
| Some cells require initialization prior to access. More...
int | GetNumberOfEdges () override
| Return the number of edges in the cell. More...
int | GetNumberOfFaces () override
| Return the number of faces in the cell. More...
void | SetEdgeIdsAndPoints (int edgeId, const std::function< void(const vtkIdType &)> &set_number_of_ids_and_points, const std::function< void(const vtkIdType &, const vtkIdType &)> &set_ids_and_points)
vtkCell * | GetFace (int) override
| Return the face cell from the faceId of the cell. More...
void | Initialize () override
int | CellBoundary (int subId, const double pcoords[3], vtkIdList *pts) override
| Given parametric coordinates of a point, return the closest cell boundary, and whether the point is inside or outside of the cell. More...
int | EvaluatePosition (const double x[3], double closestPoint[3], int &subId, double pcoords[3], double &dist2, double weights[]) override
| Given a point x[3] return inside(=1), outside(=0) cell, or (-1) computational problem encountered; evaluate parametric coordinates, sub-cell id (!=0 only if cell is composite), distance squared of point x[3] to cell (in particular, the sub-cell indicated), closest point on cell to x[3] (unless closestPoint is null, in which case, the closest point and dist2 are not found), and interpolation weights in cell. More...
void | EvaluateLocation (int &subId, const double pcoords[3], double x[3], double *weights) override
| Determine global coordinate (x[3]) from subId and parametric coordinates. More...
void | Contour (double value, vtkDataArray *cellScalars, vtkIncrementalPointLocator *locator, vtkCellArray *verts, vtkCellArray *lines, vtkCellArray *polys, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd) override
| Generate contouring primitives. More...
void | Clip (double value, vtkDataArray *cellScalars, vtkIncrementalPointLocator *locator, vtkCellArray *polys, vtkPointData *inPd, vtkPointData *outPd, vtkCellData *inCd, vtkIdType cellId, vtkCellData *outCd, int insideOut) override
| Cut (or clip) the cell based on the input cellScalars and the specified value. More...
int | IntersectWithLine (const double p1[3], const double p2[3], double tol, double &t, double x[3], double pcoords[3], int &subId) override
| Intersect with a ray. More...
int | Triangulate (int index, vtkIdList *ptIds, vtkPoints *pts) override
| Generate simplices of proper dimension. More...
void | JacobianInverse (const double pcoords[3], double **inverse, double *derivs)
void | Derivatives (int subId, const double pcoords[3], const double *values, int dim, double *derivs) override
| Compute derivatives given cell subId and parametric coordinates. More...
void | SetParametricCoords ()
double * | GetParametricCoords () override
| Return a contiguous array of parametric coordinates of the points defining this cell. More...
int | GetParametricCenter (double pcoords[3]) override
| Return center of the cell in parametric coordinates. More...
double | GetParametricDistance (const double pcoords[3]) override
| Return the distance of the parametric coordinate provided to the cell. More...
vtkIdType | GetOrder () const
vtkIdType | ComputeOrder ()
void | ToBarycentricIndex (vtkIdType index, vtkIdType *bindex)
vtkIdType | ToIndex (const vtkIdType *bindex)
Public Member Functions inherited from vtkNonLinearCell
vtkNonLinearCell * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | IsLinear () override
| Non-linear cells require special treatment (tessellation) when converting to graphics primitives (during mapping). More...
Public Member Functions inherited from vtkCell
vtkCell * | NewInstance () const
void | Initialize (int npts, const vtkIdType *pts, vtkPoints *p)
| Initialize cell from outside with point ids and point coordinates specified. More...
void | Initialize (int npts, vtkPoints *p)
| Initialize the cell with point coordinates specified. More...
virtual void | ShallowCopy (vtkCell *c)
| Copy this cell by reference counting the internal data structures. More...
virtual void | DeepCopy (vtkCell *c)
| Copy this cell by completely copying internal data structures. More...
virtual int | IsExplicitCell ()
| Explicit cells require additional representational information beyond the usual cell type and connectivity list information. More...
virtual int | RequiresExplicitFaceRepresentation ()
| Determine whether the cell requires explicit face representation, and methods for setting and getting the faces (see vtkPolyhedron for example usage of these methods). More...
virtual void | SetFaces (vtkIdType *vtkNotUsed(faces))
virtual vtkIdType * | GetFaces ()
vtkPoints * | GetPoints ()
| Get the point coordinates for the cell. More...
vtkIdType | GetNumberOfPoints ()
| Return the number of points in the cell. More...
vtkIdList * | GetPointIds ()
| Return the list of point ids defining the cell. More...
vtkIdType | GetPointId (int ptId)
| For cell point i, return the actual point id. More...
void | GetBounds (double bounds[6])
| Compute cell bounding box (xmin,xmax,ymin,ymax,zmin,zmax). More...
double * | GetBounds ()
| Compute cell bounding box (xmin,xmax,ymin,ymax,zmin,zmax). More...
double | GetLength2 ()
| Compute Length squared of cell (i.e., bounding box diagonal squared). More...
virtual int | IsPrimaryCell ()
| Return whether this cell type has a fixed topology or whether the topology varies depending on the data (e.g., vtkConvexPointSet). More...
virtual void | InterpolateFunctions (const double vtkNotUsed(pcoords)[3], double *vtkNotUsed(weight))
| Compute the interpolation functions/derivatives (aka shape functions/derivatives) No-ops at this level. More...
virtual void | InterpolateDerivs (const double vtkNotUsed(pcoords)[3], double *vtkNotUsed(derivs))
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions
static vtkLagrangeTriangle * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkLagrangeTriangle * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkHigherOrderTriangle
static vtkTypeBool | IsTypeOf (const char *type)
static vtkHigherOrderTriangle * | SafeDownCast (vtkObjectBase *o)
static void | BarycentricIndex (vtkIdType index, vtkIdType *bindex, vtkIdType order)
static vtkIdType | Index (const vtkIdType *bindex, vtkIdType order)
static double | eta (vtkIdType n, vtkIdType chi, double sigma)
static double | d_eta (vtkIdType n, vtkIdType chi, double sigma)
Static Public Member Functions inherited from vtkNonLinearCell
static vtkTypeBool | IsTypeOf (const char *type)
static vtkNonLinearCell * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkCell
static vtkTypeBool | IsTypeOf (const char *type)
static vtkCell * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkLagrangeTriangle ()
| ~vtkLagrangeTriangle () override
vtkIdType | GetNumberOfSubtriangles () const
vtkIdType | ComputeNumberOfSubtriangles ()
Protected Member Functions inherited from vtkHigherOrderTriangle
| vtkHigherOrderTriangle ()
| ~vtkHigherOrderTriangle () override
vtkIdType | GetNumberOfSubtriangles () const
vtkIdType | ComputeNumberOfSubtriangles ()
void | SubtriangleBarycentricPointIndices (vtkIdType cellIndex, vtkIdType(&pointBIndices)[3][3])
Protected Member Functions inherited from vtkNonLinearCell
| vtkNonLinearCell ()
| ~vtkNonLinearCell () override
Protected Member Functions inherited from vtkCell
| vtkCell ()
| ~vtkCell () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkNew< vtkLagrangeCurve > | EdgeCell
Protected Attributes inherited from vtkHigherOrderTriangle
vtkTriangle * | Face
vtkDoubleArray * | Scalars
vtkIdType | Order
vtkIdType | NumberOfSubtriangles
vtkSmartPointer< vtkPoints > | PointParametricCoordinates
std::vector< vtkIdType > | BarycentricIndexMap
std::vector< vtkIdType > | IndexMap
std::vector< vtkIdType > | SubtriangleIndexMap
Protected Attributes inherited from vtkCell
double | Bounds [6]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Public Attributes inherited from vtkCell
vtkPoints * | Points
vtkIdList * | PointIds

## Detailed Description

A 2D cell that represents an arbitrary order Lagrange triangle.

vtkLagrangeTriangle is a concrete implementation of vtkCell to represent a 2D triangle using Lagrange shape functions of user specified order.

The number of points in a Lagrange cell determines the order over which they are iterated relative to the parametric coordinate system of the cell. The first points that are reported are vertices. They appear in the same order in which they would appear in linear cells. Mid-edge points are reported next. They are reported in sequence. For two- and three-dimensional (3D) cells, the following set of points to be reported are face points. Finally, 3D cells report points interior to their volume.

Definition at line 43 of file vtkLagrangeTriangle.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkHigherOrderTriangle vtkLagrangeTriangle::Superclass

Definition at line 47 of file vtkLagrangeTriangle.h.

## Constructor & Destructor Documentation

## ◆ vtkLagrangeTriangle()

vtkLagrangeTriangle::vtkLagrangeTriangle | ( |  | ) |
| protected

## ◆ ~vtkLagrangeTriangle()

vtkLagrangeTriangle::~vtkLagrangeTriangle | ( |  | ) |
| override protected

## Member Function Documentation

## ◆ New()

static vtkLagrangeTriangle* vtkLagrangeTriangle::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkLagrangeTriangle::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkLagrangeTriangle::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkHigherOrderTriangle.

## ◆ SafeDownCast()

static vtkLagrangeTriangle* vtkLagrangeTriangle::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkLagrangeTriangle::NewInstanceInternal | ( |  | ) | const
| protected virtual

Reimplemented from vtkHigherOrderTriangle.

## ◆ NewInstance()

vtkLagrangeTriangle* vtkLagrangeTriangle::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkLagrangeTriangle::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| override virtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkHigherOrderTriangle.

## ◆ GetCellType()

int vtkLagrangeTriangle::GetCellType | ( |  | ) |
| inline override virtual

Return the type of cell.

Implements vtkHigherOrderTriangle.

Definition at line 49 of file vtkLagrangeTriangle.h.

## ◆ GetEdge()

vtkCell* vtkLagrangeTriangle::GetEdge | ( | int | edgeId | ) |
| override virtual

Return the edge cell from the edgeId of the cell.

Implements vtkHigherOrderTriangle.

## ◆ InterpolateFunctions()

void vtkLagrangeTriangle::InterpolateFunctions | ( | const double | pcoords[3],
|  | double * | weights
| ) |  |
| override virtual

Implements vtkHigherOrderTriangle.

## ◆ InterpolateDerivs()

void vtkLagrangeTriangle::InterpolateDerivs | ( | const double | pcoords[3],
|  | double * | derivs
| ) |  |
| override virtual

Implements vtkHigherOrderTriangle.

## ◆ getEdgeCell()

virtual vtkHigherOrderCurve* vtkLagrangeTriangle::getEdgeCell | ( |  | ) |
| override virtual

Implements vtkHigherOrderTriangle.

## ◆ GetNumberOfSubtriangles()

vtkIdType vtkLagrangeTriangle::GetNumberOfSubtriangles | ( |  | ) | const
| inline protected

Definition at line 61 of file vtkLagrangeTriangle.h.

## ◆ ComputeNumberOfSubtriangles()

vtkIdType vtkLagrangeTriangle::ComputeNumberOfSubtriangles | ( |  | ) |
| protected

## Member Data Documentation

## ◆ EdgeCell

vtkNew<vtkLagrangeCurve> vtkLagrangeTriangle::EdgeCell
| protected

Definition at line 63 of file vtkLagrangeTriangle.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkLagrangeTriangle.h